<?php

/*---------------------------------------------
  MAIAN SEARCH v2.0
  Written by David Ian Bennett
  E-Mail: support@maianscriptworld.co.uk
  Website: www.maianscriptworld.co.uk
  This File: Program Functions
----------------------------------------------*/

// Removes potential harmful tags
function cleanEvilTags($data) {
  $data = preg_replace("/javascript/i", "j&#097;v&#097;script",$data);
  $data = preg_replace("/alert/i", "&#097;lert",$data);
  $data = preg_replace("/about:/i", "&#097;bout:",$data);
  $data = preg_replace("/onmouseover/i", "&#111;nmouseover",$data);
  $data = preg_replace("/onclick/i", "&#111;nclick",$data);
  $data = preg_replace("/onload/i", "&#111;nload",$data);
  $data = preg_replace("/onsubmit/i", "&#111;nsubmit",$data);
  $data = preg_replace("/<body/i", "&lt;body",$data);
  $data = preg_replace("/<html/i", "&lt;html",$data);
  $data = preg_replace("/document\./i", "&#100;ocument.",$data);

  return trim(strip_tags($data));
}

// Admin pagination..
function searchPageNumbers($count,$limit,$page,$todisplay=20,$stringVar='next') {
  global $script10,$script11;
  $PaginateIt = new PaginateIt();
  $PaginateIt->SetCurrentPage($page);
  $PaginateIt->SetItemCount($count);
  $PaginateIt->SetItemsPerPage($limit);
  $PaginateIt->SetLinksToDisplay($todisplay);
  $PaginateIt->SetQueryStringVar($stringVar);
  $PaginateIt->SetLinksFormat('&laquo; '.$script10,
                              ' &bull; ',
                              $script11.' &raquo;'
  );

  return $PaginateIt->GetPageLinks();
}

// Displays no results message..
function noResultsToDisplay() {
  global $search2;
  return str_replace('{text}',$search2,file_get_contents(PATH.'templates/html/no-results.htm'));
}

// Logs keyword/phrases to log file..
function addToLogFile($key) {
  global $database;
  $q_log = mysql_query("SELECT count(*) as log_count FROM ".$database['prefix']."logfile 
           WHERE keywords = '".safeImport($key)."' 
           LIMIT 1
           ") or die(mysql_error());
  $CLOG = mysql_fetch_object($q_log);         
  if (isset($CLOG->log_count) && $CLOG->log_count>0) {
    mysql_query("UPDATE ".$database['prefix']."logfile SET 
    count          = (count+1) 
    WHERE keywords = '".safeImport($key)."' 
    LIMIT 1
    ") or die(mysql_error());
  } else {
    mysql_query("INSERT INTO ".$database['prefix']."logfile (
    keywords,count
    ) VALUES (
    '".safeImport($key)."',
    '1'
    )") or die(mysql_error());
  }
}

// Gets data based on param criteria..
function getTableData($table,$row,$id,$and='') {
  global $database;
  $query = mysql_query("SELECT * FROM ".$database['prefix'].$table."
           WHERE $row  = '$id'
           $and
           LIMIT 1
           ") or die(mysql_error());
  return mysql_fetch_object($query);
}

// Gets row count..
function rowCount($table,$where='') {
  global $database;
  $query = mysql_query("SELECT count(*) AS r_count FROM ".$database['prefix'].$table.$where."") or die(mysql_error());
  $row = mysql_fetch_object($query);
  return str_replace(',','',$row->r_count);
}

// Prepares date for safe mysql import..
function safeImport($data) {
  if (get_magic_quotes_gpc()) {
    $data = stripslashes($data);
  }
  return mysql_real_escape_string($data);
}

// Cleans output data.. 
function cleanData($data) {
  $data = str_replace(' & ', ' &amp; ', $data);
  return (get_magic_quotes_gpc() ? stripslashes($data) : $data);
}

// Recursive way of handling multi dimensional arrays..
// This cleans query string data and prevents code injections..
function multiDimensionalArrayMap($func,$arr) {
  $newArr = array();
  if (!empty($arr)) {
    foreach($arr AS $key => $value) {
      $newArr[$key] = (is_array($value) ? multiDimensionalArrayMap($func,$value) : $func($value));
    }
  }
  return $newArr;
}

// Clean query string array input..
$_GET  = multiDimensionalArrayMap('cleanEvilTags', $_GET);
$_GET  = multiDimensionalArrayMap('htmlspecialchars', $_GET);

?>
